import os
import sys
import subprocess
import itertools
 

## Dataset choice
DATA_tab=["cifar10"]

## Architecture choice 
ARCH_tab=["vgg16_bn","vgg16_under_d2_bn","vgg16_under_d4_bn","vgg16_under_d8_bn","vgg16_under_d16_bn"]

## Optimizer choices
OPT_tab=[str("sgd")]
LR_tab=[ 0.08]
BATCH_tab = [128]
M_tab =[0.9]
A_tab=[(180,255)] 
WD_tab=[9e-4]

## Seeds
value={}
value["vgg16_bn"]=80+1
value["vgg16_under_d2_bn"]=80+1
value["vgg16_under_d4_bn"]=180+1
value["vgg16_under_d8_bn"]=330+1
value["vgg16_under_d16_bn"]=532+1

value["resnet18_bn"]=80+1
value["resnet18_under_d2_bn"]=80+1
value["resnet18_under_d4_bn"]=180+1
value["resnet18_under_d8_bn"]=330+1
value["resnet18_under_d16_bn"]=538+1



for arch in ARCH_tab:
    list_param=[]
    SEED_tab=list(range(501,500+value[arch])) if "vgg" in arch else list(range(1,value[arch]))
    list_param=[SEED_tab,DATA_tab,[arch],OPT_tab,LR_tab,BATCH_tab,M_tab,A_tab,WD_tab]
    list_param=  list(itertools.product(*list_param))

    SAVE="False"

    ###########

    SAVEMODEL="False"
    MODELRANDOM="True"

    #########

    for l in list_param:
      
        SEED=l[0]
        DATA=l[1]
        ARCH=l[2]
        OPT=l[3]
        LR=l[4]
        BATCH=l[5]
        M=l[6]
        A=l[7]
        WD=l[8]
 
 

        
        FA=A[0]
        SA=A[1]
    
                            
        subprocess.call(['sbatch', 'cifar_exec.slurm', str(SEED), DATA, ARCH, OPT,\
                  str(LR), str(BATCH), str(M), str(FA), str(SA), str(WD),\
                  str(SAVE),str(SAVEMODEL), str(MODELRANDOM)])
                     
print('done')
