import argparse
import os
import shutil
from datetime import datetime

import sys
sys.path.insert(1, '..')

import pandas as pd
import numpy as np
import torch 
import torch.backends.cudnn as cudnn
import torch.optim
import torch.nn as nn
import numpy as np
import train_util
import data_util
#import eval_loss_util
from sklearn.model_selection import train_test_split

#from sklearn.model_selection import GridSearchCV

from sklearn.linear_model import RidgeCV
#from sklearn.model_selection import KFold
import numpy as np
#from sklearn.pipeline import make_pipeline
from sklearn.preprocessing import StandardScaler
from sklearn import metrics


import models as models
#from models import vgg16, vgg16_bn, resnet110, resnet110_bn

import numpy as np


device = 'cuda' if torch.cuda.is_available() else 'cpu'

from sys import argv 


import torchvision
from torch.utils import data
from torchvision import datasets
from torchvision import transforms
import torch
import os
import numpy as np
import torch.nn.functional as F

import time

first=argv[1] 
second=argv[2]
under_model=argv[3]
over_model=argv[4]


if under_model=="vgg16_under_d2_bn" or under_model=="resnet18_under_d2_bn":
    concat_number1=4

if under_model=="vgg16_under_d4_bn" or under_model=="resnet18_under_d4_bn":
    concat_number1=16

if under_model=="vgg16_under_d8_bn" or under_model=="resnet18_under_d8_bn":
    concat_number1=64

if under_model=="vgg16_under_d16_bn":
    concat_number1=251

if under_model=="resnet18_under_d16_bn":
    concat_number1=254


transform_train = transforms.Compose([
transforms.ToTensor(),
#transforms.Resize
transforms.Normalize((0.4914, 0.4822, 0.4465), (0.2023, 0.1994, 0.2010))])

transform_test = transforms.Compose([
    transforms.ToTensor(),
    transforms.Normalize((0.4914, 0.4822, 0.4465), (0.2023, 0.1994, 0.2010)),
])

path_data="../data/"

trainset = torchvision.datasets.CIFAR10(
                root=path_data, train=True, download=True, transform=transform_train)

testset = torchvision.datasets.CIFAR10(
            root=path_data, train=False, download=True, transform=transform_test)


trainloader = torch.utils.data.DataLoader(
                trainset, batch_size=100, shuffle=False, num_workers=4)

val_loader = torch.utils.data.DataLoader(
            testset, batch_size=100, shuffle=False, num_workers=4)  

np.random.seed(0)

cl="/results"


start = time.time()


print(first+second)

for se1 in range(1,5):
    curr_dir="../"+cl
    modelos=[]

    if first=="to":
        paths=[]
        paths.append(curr_dir + "/"+over_model+"/"+"result_trained_"+str(se1))
        #print(paths[-1])
            
        for path in paths:
            print(path)
            modelos.append(torch.load(path,map_location=torch.device('cpu')))
                
    elif first=="tu":
        paths=[]
        for i in range(30+1,30+1+concat_number1):
            paths.append(curr_dir + "/"+under_model+"/"+"result_trained_"+str( i +(se1-1)* concat_number1 ))
            #print(paths[-1])
            
        for path in paths:
            print(path)
            modelos.append(torch.load(path,map_location=torch.device('cpu')))
            

    X_training_c=0
    X_test_c=0
    
    X_training_cs=[]
    X_test_cs=[]
    
    while(len(modelos)):
        modelo=modelos.pop()
	
        X_training=0
        X_test=0
        target_training=0
        target_test=0

        X_trainings=[]
        target_trainings=[]
        X_tests=[]
        target_tests=[]

        modelo.eval()
        with torch.no_grad():
           for batch_idx, (inputs, targets) in enumerate(trainloader):
              inputs, targets = inputs.to(device), targets.to(device)
              
              X_trainings.append(modelo.get_features(inputs).detach())
              target_trainings.append(targets)

        X_training=torch.cat(X_trainings,dim=0)
        target_training= torch.cat(target_trainings,dim=0)
        
        modelo.eval()
        with torch.no_grad():
           for batch_idx, (inputs, targets) in enumerate(val_loader):
              inputs, targets = inputs.to(device), targets.to(device)
              X_tests.append(modelo.get_features(inputs).detach())
              target_tests.append(targets)
        
        X_test=torch.cat(X_tests,dim=0)
        target_test= torch.cat(target_tests,dim=0)

        del modelo
        
        X_training_cs.append(X_training)
        X_test_cs.append(X_test)
    
    X_test_c=torch.cat(X_test_cs, dim=1)
    X_training_c=torch.cat(X_training_cs, dim=1)
     
    X_training=X_training_c.cpu().numpy()
    del X_training_c
    
    X_test=X_test_c.cpu().numpy()
    del X_test_c

    target_test=target_test.cpu().detach().numpy().reshape(-1,1) 
    target_training=target_training.cpu().detach().numpy().reshape(-1,1) 


    #scaler=StandardScaler()
    #X_training = scaler.fit_transform(X_training)
    #X_test = scaler.transform(X_test)
    
    ######################################
    ##concatenate the target
    #########
    
    
    print(se1)
    print(first)
    print(second)
    
    modelus=[]
    
    if second=="to":
        paths=[]
        paths.append(curr_dir + "/"+over_model+"/"+"result_trained_"+str(se1))
       
        for path in paths:
            modelus.append(torch.load(path,map_location=torch.device('cpu')))
            print(paths[-1])
            
         
    elif second=="tu":
        paths=[]
        for i in range(30+1,30+1+concat_number1):
            paths.append(curr_dir + "/"+under_model+"/"+"result_trained_"+str( i +(se1-1)* concat_number1 ))
            print(paths[-1])
       
        for path in paths:
            modelus.append(torch.load(path,map_location=torch.device('cpu')))
            

    
    Y_training_c=0
    Y_test_c=0
    
    Y_training_cs=[]
    Y_test_cs=[]
    
    while(len(modelus)):

        modelu=modelus.pop()	
    
        Y_trainings=[]
        Y_tests=[]

        modelu.eval()
        with torch.no_grad():
           for batch_idx, (inputs, targets) in enumerate(trainloader):
              inputs, targets = inputs.to(device), targets.to(device)
              Y_trainings.append(modelu.get_features(inputs).detach())
        
        Y_training=torch.cat(Y_trainings,dim=0)
        
        modelu.eval()
        with torch.no_grad():
           for batch_idx, (inputs, targets) in enumerate(val_loader):
              inputs, targets = inputs.to(device), targets.to(device)
              Y_tests.append(modelu.get_features(inputs).detach())
       
        Y_test=torch.cat(Y_tests,dim=0)
             
        del modelu
       
        Y_training_cs.append(Y_training)
        Y_test_cs.append(Y_test)
   
    Y_test_c=torch.cat(Y_test_cs, dim=1)
    Y_training_c=torch.cat(Y_training_cs, dim=1)
           
    print("finished")
                

    Y_training=Y_training_c.cpu().numpy()
    del Y_training_c
    Y_test=Y_test_c.cpu().numpy()
    del Y_test_c
    

    print("size before split")
    print(X_training[0].size)
    print(X_training[:,0].size)
    print(Y_training[0].size)
    print(Y_training[:,0].size)
    print(X_test[0].size)
    print(X_test[:,0].size)
    print(Y_test[0].size)
    print(Y_test[:,0].size)
    

    scaler=StandardScaler()
    X_training = scaler.fit_transform(X_training)
    X_test = scaler.transform(X_test)

    print("TIME:::::::::::::")
    print(time.time() - start)
    print("::::::::::::::::::::::")
            

    errors_validation=[]
    errors_training=[]
    errors_test=[]

    siz=len(Y_training[0])

    alphas= np.array([0.00001,0.0001,0.005,0.001,0.05,0.01,0.1,0.5,1,2,3,5,7,8,10,11,13,15,20,25,30,35,40,45,50,55,65,75,80,90,100,110,125,140,160,180,200,250,300,400,500,600,700,850,1000,1200,1400,1500,1600,1800,2000,2100,2200,2500,3000,3500,4000,4500,5000,6000,7000,8000,9000,10000,11000,12000,13000,14000,15000,16000,20000,30000])
    nalphass=np.linspace(1000,10000,91)
    alphas=np.concatenate((nalphass,alphass))
    alphas=np.sort(alphas)
    alphas=np.unique(alphas)
    
    
    clf = RidgeCV(alphas=alphas, cv= None, alpha_per_target=True, scoring="r2").fit(X_training, Y_training)
     
    alphastars=clf.alpha_
    print("best_alpha_indeces")
    print(alphastars)
    
    Yhat_training = clf.predict(X_training)
    epsilon_training= Y_training-Yhat_training

    Yhat_test = clf.predict(X_test)
    epsilon_test= Y_test-Yhat_test

    #generate features
    curr_dir=os.getcwd()+"/predicted_features/"
    curr_dir=curr_dir+"/"+over_model+"/"+under_model

    if not os.path.exists(curr_dir): 
        os.makedirs(curr_dir)

    if first=="to":
        print(curr_dir + "/under_" + 'epsilon_' +str(se1)+ '_training.csv')
        pd.DataFrame(epsilon_training).to_csv(curr_dir + "/under_" + 'epsilon_' +str(se1)+ '_training.csv',header=False, index=False)
        pd.DataFrame(epsilon_test).to_csv(curr_dir + "/under_" + 'epsilon_' +str(se1)+ '_test.csv',header=False, index=False)
    else:
        print(curr_dir + "/over_" + 'epsilon_' +str(se1)+ '_training_csv')
        pd.DataFrame(epsilon_training).to_csv(curr_dir + "/over_" + 'epsilon_' +str(se1)+ '_training.csv',header=False, index=False)
        pd.DataFrame(epsilon_test).to_csv(curr_dir + "/over_" + 'epsilon_' +str(se1)+ '_test.csv',header=False, index=False)   
    


    print("TIME:::::::::::::")
    print(time.time() - start)
    print("::::::::::::::::::::::")


    #siz=int(siz/concat_number1)
    #print(siz)
    #for i in range(1, concat_number1+1):
    #    folder= curr_dir + "/" +str(30+i +(se1-1)* concat_number1 )
    #    if not os.path.exists(folder): 
    #        os.makedirs(folder)
    #    print(folder)
    #    pd.DataFrame(np.concatenate((target_training,Yhat_training[:,(i-1)*siz:i*siz]), axis=1)).to_csv(folder + "/" + 'training.csv',header=False, index=False)
    #    pd.DataFrame(np.concatenate((target_test,Yhat_test[:,(i-1)*siz:i*siz]), axis=1)).to_csv(folder + "/" + 'test.csv',header=False, index=False)

    print("TIME:::::::::::::")
    print(time.time() - start)
    print("::::::::::::::::::::::")

   
    
    

       
